import 'dart:io';

import 'package:flutter/material.dart';
import 'package:signature/signature.dart';

class TechlifySignature extends StatefulWidget {
  TechlifySignature({
    Key key,
  }) : super(key: key);

  @override
  _TechlifySignatureState createState() => _TechlifySignatureState();
}

class _TechlifySignatureState extends State<TechlifySignature> {
  File signatureFile;
  final SignatureController _controller = SignatureController(
    penStrokeWidth: 4,
    penColor: Colors.blue,
    exportBackgroundColor: Colors.transparent,
  );

  @override
  Widget build(BuildContext context) {
    final size = MediaQuery.of(context).size;
    var _signatureCanvas = Signature(
      controller: _controller,
      width: size.width * 0.7,
      height: size.height * 0.35,
      backgroundColor: Colors.blueGrey[50],
    );
    _controller.clear();

    return Container(
      width: size.width < 800 ? size.width * 0.7 : size.width * 0.7,
      height: size.height < 450 ? size.height * 0.9 : size.height * 0.5,
      child: Column(
        mainAxisAlignment: MainAxisAlignment.spaceAround,
        children: [
          SizedBox(height: 20),
          Row(
            mainAxisAlignment: MainAxisAlignment.end,
            children: [
              Text(
                'Sign Here',
                style: TextStyle(fontWeight: FontWeight.bold, fontSize: 22),
              ),
              SizedBox(
                width: size.width * .24,
              ),
              FlatButton(
                child: Text('clear'),
                onPressed: () => _controller.clear(),
              ),
            ],
          ),
          SizedBox(height: 20),
          Expanded(child: _signatureCanvas), //signature canvas
          Row(
            mainAxisAlignment: MainAxisAlignment.center,
            crossAxisAlignment: CrossAxisAlignment.center,
            children: [
              Column(
                children: [
                  SizedBox(height: 20),
                  FlatButton(
                    child: Text('cancel'),
                    onPressed: () => Navigator.pop(context, null),
                  ),
                ],
              ),
              Padding(
                  padding: EdgeInsets.fromLTRB(20, 20, 20, 0),
                  child: RaisedButton(
                    elevation: 8,
                    color: Colors.blueGrey,
                    onPressed: () async {
                      var signData = await _controller.toPngBytes();

                      Navigator.pop(context, signData);
                      setState(() {});
                    },
                    child: Text('Save', style: TextStyle(color: Colors.white)),
                    shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.circular(18.0),
                    ),
                  ))
            ],
          ),
          SizedBox(height: 10)
        ],
      ),
    );
  }
}
